<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Installing on CentOS 7</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="installing-on-centos-7">Installing on CentOS 7</h1>
<h2 id="lamp-linux-apache-mysqlmariadb-php-required-packages">LAMP (Linux, Apache, MySQL/MariaDB, PHP) Required packages</h2>
<h3 id="web-server-apache">Web Server (Apache)</h3>
<ol>
<li><p>Enable Epel repo to enable PHP 7.2 package download</p>
<pre class="console"><code>yum install &lt;http://rpms.remirepo.net/enterprise/remi-release-7.rpm&gt; -y
yum install yum-utils -y
yum-config-manager --enable remi-php72
</code></pre></li>
<li><p>Install Apache</p>
<pre class="console"><code>yum install -y httpd
</code></pre></li>
<li><p>Enable and start the service to ensure it starts when the system reboots</p>
<pre class="console"><code>systemctl start httpd
systemctl enable httpd
</code></pre></li>
</ol>
<h3 id="example-configuration-file-for-apache-24-and-ssl">Example configuration file for Apache 2.4 and SSL</h3>
<p>This example configuration assumes you have your own certificates already. You should make sure you change the paths to match your setup.</p>
<p>Replace <code>YourOwnCertFile.crt</code> and <code>YourOwnCertFile.key</code> with the names of the files holding your certificate (<code>.crt</code>) and private key (<code>.key</code>).</p>
<pre class="console"><code>#
# Cacti: An RRDtool based graphing web application
#

# For security reasons, the Cacti web interface is accessible only to
# localhost in the default configuration. If you want to allow other clients
# to access your Cacti installation, change the httpd ACLs below.
# For example:
# On httpd 2.4, change &quot;Require host localhost&quot; to &quot;Require all granted&quot;.
# On httpd 2.2, change &quot;Allow from localhost&quot; to &quot;Allow from all&quot;.

&lt;VirtualHost *:443&gt;
    LogLevel warn

    ServerName cacti.yourdomain.com
    ServerAdmin  admin@yourdomain.com

    DocumentRoot &quot;/var/www/html/cacti&quot;
    Alias /cacti    /var/www/html/cacti
    SSLEngine On
    SSLCertificateFile /etc/ssl/certs/YourOwnCertFile.crt
    SSLCertificateKeyFile /etc/ssl/private/YourOwnCertKey.key

    &lt;Directory /var/www/html/cacti/&gt;
        &lt;IfModule mod_authz_core.c&gt;
                # httpd 2.4
                Require all granted
        &lt;/IfModule&gt;
        &lt;IfModule !mod_authz_core.c&gt;
                # httpd 2.2
                Order deny,allow
                Deny from all
                Allow from all
        &lt;/IfModule&gt;
    &lt;/Directory&gt;

    &lt;Directory /var/www/html/cacti/install&gt;
        # mod_security overrides.
        # Uncomment these if you use mod_security.
        # allow POST of application/x-www-form-urlencoded during install
        #SecRuleRemoveById 960010
        # permit the specification of the RRDtool paths during install
        #SecRuleRemoveById 900011
    &lt;/Directory&gt;

    # These sections marked &quot;Require all denied&quot; (or &quot;Deny from all&quot;)
    # should not be modified.
    # These are in place in order to harden Cacti.
    &lt;Directory /var/www/html/cacti/log&gt;
        &lt;IfModule mod_authz_core.c&gt;
                Require all denied
        &lt;/IfModule&gt;
        &lt;IfModule !mod_authz_core.c&gt;
                Order deny,allow
                Deny from all
        &lt;/IfModule&gt;
    &lt;/Directory&gt;
    &lt;Directory /var/www/html/cacti/rra&gt;
        &lt;IfModule mod_authz_core.c&gt;
                Require all denied
        &lt;/IfModule&gt;
        &lt;IfModule !mod_authz_core.c&gt;
                Order deny,allow
                Deny from all
        &lt;/IfModule&gt;
    &lt;/Directory&gt;
&lt;/VirtualHost&gt;
</code></pre>
<h3 id="database-server">Database Server</h3>
<p>The choice between MySQL server and MariaDB is normally down to the OS maintainers if you use one of the predefined LAMP setup installations. If you are deciding between these yourself, you should research this via your favorite search engine.</p>
<p>Whilst MySQL is the original open source SQL database server created in 1995 which is now owned by Oracle, MariaDB is designed as a drop-in replacement by some of the original MySQL developers / owners. This will likely continue to be a drop-in alternative until there is a major divergence that can not be bridged.</p>
<h4 id="mysql">MySQL</h4>
<ol>
<li><p>Install MySQL server</p>
<pre class="console"><code>yum install -y mysql mysql-server
</code></pre></li>
<li><p>Enable and start the service to ensure it starts when the system reboots</p>
<pre class="console"><code>systemctl enable mysqld
systemctl start mysqld
</code></pre></li>
</ol>
<h4 id="mariadb">MariaDB</h4>
<ol>
<li><p>Install MariaDB server</p>
<pre class="console"><code>yum install -y MariaDB-server MariaDB-client
</code></pre></li>
<li><p>Enable and start the service to ensure it starts when the system reboots</p>
<pre class="console"><code>systemctl enable mariadb
systemctl start mariadb
</code></pre></li>
</ol>
<h3 id="mysqlmariadb-common-tasks-and-recommendations">MySQL/MariaDB common tasks and recommendations</h3>
<p><strong>IMPORTANT</strong>: Secure your MySQL installation before doing any more changes</p>
<pre class="console"><code>/usr/bin/mysql_secure_installation
</code></pre>
<p>The following MySQL/MariaDB recommendations may vary depending on your system setup. In any case, Cacti will prompt you with more accurate recommendations during the installation.</p>
<ol>
<li><p>Edit your <code>server.cnf</code> file</p>
<pre class="console"><code>vim /etc/my.cnf.d/server.cnf
</code></pre>
<p>The following <code>[mysqld]</code> section is a base configuration. The installer will provide recommendations based on the actual system which will be more tailored to your environment.</p>
<pre class="shell"><code>[mysqld]
character-set-server=utf8mb4
collation-server=utf8mb4_unicode_ci
innodb_file_format = Barracuda
max_allowed_packet = 16777777
join_buffer_size = 32M
innodb_file_per_table = ON
innodb_large_prefix = 1
innodb_buffer_pool_size = 250M
innodb_additional_mem_pool_size = 90M
innodb_flush_log_at_trx_commit = 2
log-error                      = /var/log/mysql/mysql-error.log
log-queries-not-using-indexes  = 1
slow-query-log                 = 1
slow-query-log-file            = /var/log/mysql/mysql-slow.log
</code></pre></li>
<li><p>Restart MySQL/MariaDB service to pick up the changes</p>
<pre class="console"><code>systemctl restart mysql
</code></pre></li>
<li><p>Populate timezone table with available timezones</p>
<pre class="console"><code>mysql_tzinfo_to_sql /usr/share/zoneinfo | mysql -u root -p mysql
</code></pre></li>
</ol>
<h4 id="setup-cacti-database">Setup Cacti database</h4>
<ol>
<li><p>Login to MySQL/MariaDB as root to create Cacti database</p>
<pre class="console"><code># mysql -u root -p
MariaDB [(none)]&gt; create database if not exists cacti;
Query OK, 1 row affected (0.00 sec)
</code></pre></li>
<li><p>Import Cacti database from SQL file</p>
<div class="sourceCode" id="cb15"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb15-1" title="1">MariaDB [(<span class="kw">none</span>)]<span class="op">&gt;</span> <span class="kw">use</span> cacti;</a>
<a class="sourceLine" id="cb15-2" title="2"><span class="kw">Database</span> changed</a>
<a class="sourceLine" id="cb15-3" title="3">MariaDB [(cacti)]<span class="op">&gt;</span> <span class="kw">source</span> <span class="op">/</span>var<span class="op">/</span>www<span class="op">/</span>html<span class="op">/</span>cacti<span class="op">/</span>cacti.sql</a></code></pre></div></li>
<li><p>Grant Cacti username access to Cacti database. Replace <code>your_cacti_username</code> and <code>your_cacti_password</code> with your own details.</p>
<div class="sourceCode" id="cb16"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb16-1" title="1">MariaDB [(<span class="kw">none</span>)]<span class="op">&gt;</span> <span class="kw">CREATE</span> <span class="fu">USER</span> <span class="st">&#39;your_cacti_username&#39;</span>@<span class="st">&#39;localhost&#39;</span> <span class="kw">IDENTIFIED</span> <span class="kw">BY</span> <span class="st">&#39;your_cacti_password&#39;</span>;</a>
<a class="sourceLine" id="cb16-2" title="2"><span class="kw">Query</span> OK, <span class="dv">0</span> <span class="kw">rows</span> affected (<span class="fl">0.00</span> sec)</a>
<a class="sourceLine" id="cb16-3" title="3">MariaDB [(<span class="kw">none</span>)]<span class="op">&gt;</span> <span class="kw">GRANT</span> <span class="kw">ALL</span> <span class="kw">PRIVILEGES</span> <span class="kw">ON</span> cacti.<span class="op">*</span> <span class="kw">TO</span> <span class="st">&#39;your_cacti_username&#39;</span>@<span class="st">&#39;localhost&#39;</span>;</a>
<a class="sourceLine" id="cb16-4" title="4"><span class="kw">Query</span> OK, <span class="dv">0</span> <span class="kw">rows</span> affected (<span class="fl">0.00</span> sec)</a></code></pre></div></li>
<li><p>Grant cacti username to MySQL timezone table</p>
<div class="sourceCode" id="cb17"><pre class="sourceCode sql"><code class="sourceCode sql"><a class="sourceLine" id="cb17-1" title="1">MariaDB [(<span class="kw">none</span>)]<span class="op">&gt;</span> <span class="kw">GRANT</span> <span class="kw">SELECT</span> <span class="kw">ON</span> mysql.time_zone_name <span class="kw">TO</span> <span class="st">&#39;your_cacti_username&#39;</span>@<span class="st">&#39;localhost&#39;</span>;</a>
<a class="sourceLine" id="cb17-2" title="2"><span class="kw">Query</span> OK, <span class="dv">0</span> <span class="kw">rows</span> affected (<span class="fl">0.00</span> sec)</a>
<a class="sourceLine" id="cb17-3" title="3">MariaDB [(<span class="kw">none</span>)]<span class="op">&gt;</span> <span class="kw">FLUSH</span> <span class="kw">PRIVILEGES</span>;</a>
<a class="sourceLine" id="cb17-4" title="4"><span class="kw">Query</span> OK, <span class="dv">0</span> <span class="kw">rows</span> affected (<span class="fl">0.00</span> sec)</a></code></pre></div></li>
</ol>
<h3 id="common-packages">Common packages</h3>
<h4 id="php">PHP</h4>
<p>PHP and various packages are all required by Cacti for successful operation</p>
<ol>
<li><p>Install PHP and required packages.</p>
<pre class="console"><code>yum install -y php php-common php-bcmath php-cli \
php-mysqlnd php-gd php-gmp php-intl \
php-json php-ldap php-mbstring \
php-pdo php-pear php-snmp php-process \
php-xml php-zip
</code></pre></li>
<li><p>Set a timezone to your PHP.INI configuration</p>
<p>Edit php.ini typically located at <code>/etc/php.ini</code></p>
<pre class="console"><code>date.timezone = Pacific/Auckland
</code></pre></li>
</ol>
<h4 id="rrdtool">RRDtool</h4>
<p>RRDtool is required to store the data retrieved from devices in <code>.rra</code> files to produce the graphs which are shown within Cacti</p>
<pre class="console"><code>yum install -y rrdtool
</code></pre>
<h4 id="snmp">SNMP</h4>
<p>SNMP is used to query most devices for information.</p>
<pre class="console"><code>yum install -y net-snmp net-snmp-utils
</code></pre>
<h3 id="cacti">Cacti</h3>
<p>The following steps will show you how to manually download, install and configure the basics for Cacti.</p>
<ol>
<li><p>Download Cacti source code from <a href="https://www.cacti.net/download_cacti.php">Cacti Web Site</a></p>
<pre class="console"><code>cd /tmp
wget https://www.cacti.net/downloads/cacti-1.y.z.tar.gz
tar -zxvf cacti-1.y.z.tar.gz
mv -v cacti-1.y.z /var/www/html/cacti
</code></pre></li>
<li><p>Edit the config.php file</p>
<pre class="console"><code>mv -v /var/www/html/cacti/include/config.php-dist /var/www/html/cacti/include/config.php
</code></pre></li>
<li><p>Update <code>database_</code> fields with your own details. This section only applies to the Main Cacti Server</p>
<div class="sourceCode" id="cb24"><pre class="sourceCode php"><code class="sourceCode php"><a class="sourceLine" id="cb24-1" title="1"><span class="kw">$database_type</span>     = <span class="st">&#39;mysql&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-2" title="2"><span class="kw">$database_default</span>  = <span class="st">&#39;your_cacti_database&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-3" title="3"><span class="kw">$database_hostname</span> = <span class="st">&#39;localhost&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-4" title="4"><span class="kw">$database_username</span> = <span class="st">&#39;your_cacti_username&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-5" title="5"><span class="kw">$database_password</span> = <span class="st">&#39;your_cacti_password&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-6" title="6"><span class="kw">$database_port</span>     = <span class="st">&#39;3306&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-7" title="7"><span class="kw">$database_ssl</span>      = <span class="kw">false</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-8" title="8"><span class="kw">$database_ssl_key</span>  = <span class="st">&#39;&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-9" title="9"><span class="kw">$database_ssl_cert</span> = <span class="st">&#39;&#39;</span><span class="ot">;</span></a>
<a class="sourceLine" id="cb24-10" title="10"><span class="kw">$database_ssl_ca</span>   = <span class="st">&#39;&#39;</span><span class="ot">;</span></a></code></pre></div></li>
<li><p>Create your cron task file or systemd units file</p>
<p>Starting with Cacti 1.2.16, you have the option to use either the legacy Crontab entry, or an optional cactid units file and server to run your Cacti pollers.</p>
<p>For Crontab use, follow the instructions below:</p>
<p>Create and edit <code>/etc/cron.d/cacti</code> file. Make sure to setup the correct path to poller.php</p>
<pre class="console"><code>*/5 * * * * apache php /var/www/html/cacti/poller.php &amp;&gt;/dev/null
</code></pre>
<p>For systemd unit's file install, you will need to modify the included units file to following your install location and desired user and group's to run the Cacti poller as. To complete the task, follow the procedure below:</p>
<pre class="console"><code>vim /var/www/html/cacti/service/cactid.service (edit the path)
touch /etc/sysconfig/cactid
cp -p /var/www/html/cacti/service/cactid.service /etc/systemd/system
systemctl enable cactid
systemctl start cactid
systemctl status cactid
</code></pre>
<p>The systemd units file makes managing a highly available Cacti setup a bit more convenient.</p></li>
</ol>
<h4 id="spine">Spine</h4>
<ol>
<li><p>Install the necessary packages to compile and install spine</p>
<pre class="console"><code>yum install -y autoconf automake libtool dos2unix help2man \
openssl-devel mariadb-devel net-snmp-devel
</code></pre></li>
<li><p>Download spine source code from <a href="https://www.cacti.net/spine_download.php">Cacti Web Site</a></p>
<p>Go to /tmp to download the source code and extract it</p>
<pre class="console"><code>cd /tmp
wget https://www.cacti.net/downloads/spine/cacti-spine-1.y.z.tar.gz
tar -zxvf cacti-spine-1.y.z.tar.gz
cd cacti-spine-1.y.z
</code></pre></li>
<li><p>Run the configure script and compile spine.</p>
<pre class="console"><code># ./configure
# make &amp;  make install
config/install-sh -c -d &#39;/usr/local/spine/bin&#39;
/bin/sh ./libtool   --mode=install /usr/bin/install -c spine &#39;/usr/local/spine/bin&#39;
libtool: install: /usr/bin/install -c spine /usr/local/spine/bin/spine
config/install-sh -c -d &#39;/usr/local/spine/etc&#39;
/usr/bin/install -c -m 644 spine.conf.dist &#39;/usr/local/spine/etc&#39;
config/install-sh -c -d &#39;/usr/local/spine/share/man/man1&#39;
/usr/bin/install -c -m 644 spine.1 &#39;/usr/local/spine/share/man/man1&#39;
</code></pre></li>
<li><p>Edit spine.conf</p>
<p>Rename spine.conf.dist to spine.conf</p>
<pre class="console"><code>mv -v /usr/local/spine/etc/spine.conf.dist /usr/local/spine/etc/spine.conf
vi /usr/local/spine/etc/spine.conf
</code></pre></li>
<li><p>Now set up your database connection</p>
<pre class="console"><code>DB_Host       localhost
DB_Database   your_cacti_database
DB_User       your_cacti_username
DB_Pass       your_cacti_password
DB_Port       3306
#DB_UseSSL    0
#RDB_SSL_Key
#RDB_SSL_Cert
#RDB_SSL_CA
</code></pre></li>
</ol>
<h3 id="security-enhanced-linux-selinux">Security Enhanced Linux (SELinux)</h3>
<p>If you are having issues to access the web page, disable SELinux temporarily to prove that the issues come from the SELinux policy. It is NOT recommended to disable SELinux permanently.</p>
<p><a href="https:////wiki.centos.org/es/HowTos/SELinux">CentOS</a> has a lot of documentation on how to make your SELinux policy right.</p>
<ol>
<li><p>Check SELinux status</p>
<pre class="console"><code>getenforce
</code></pre></li>
<li><p>Disable SELinux temporarily</p>
<pre class="console"><code>setenforce 0
</code></pre></li>
<li><p>Enable SELinux back</p>
<pre class="console"><code>setenforce 1
</code></pre></li>
</ol>
<p><strong>Note:</strong> If you installed Cacti out of <code>/var/www/html</code> make sure you fix up all SELinux context and permissions.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
